import { Flow, FlowSchema } from '.';
import { Action } from '../Actions';
import { InteractionContext, SmsCookie } from '../SmsCookie';
import { TwilioWebhookRequest } from '../twllio';
import { ErrorHandler } from '../util';
export declare type ExitKeywordTest = (body: string) => (boolean | Promise<boolean>);
export declare type InteractionEndHook = (context: InteractionContext, userCtx: any) => any;
export interface FlowControllerOptions {
    onInteractionEnd?: InteractionEndHook;
    testForExit?: ExitKeywordTest;
}
export default class FlowController {
    private readonly root;
    private readonly schema;
    private testForExit;
    onInteractionEnd: InteractionEndHook;
    constructor(root: Flow, schema?: FlowSchema, { onInteractionEnd, testForExit, }?: FlowControllerOptions);
    private getCurrentFlow;
    resolveActionFromState(req: TwilioWebhookRequest, state: SmsCookie, userCtx: any, handleError: ErrorHandler): Promise<Action>;
    resolveNextStateFromAction(req: TwilioWebhookRequest, state: SmsCookie, action: Action): SmsCookie;
}
