import { Action } from '../Actions';
import { InteractionContext } from '../SmsCookie';
export declare type FlowActionResolver = (context: InteractionContext, userContext?: any) => Action | Promise<Action>;
interface FlowAction {
    name: string;
    resolve: FlowActionResolver;
}
declare const FlowName: unique symbol;
declare const FlowActions: unique symbol;
declare const FlowActionNames: unique symbol;
export default class Flow {
    private readonly [FlowActions];
    private readonly [FlowActionNames];
    readonly [FlowName]: string;
    constructor(name: string);
    readonly length: number;
    readonly name: string;
    addAction(name: string, resolve: FlowActionResolver): Flow;
    addActions(actions: FlowAction[]): Flow;
    selectActionResolver(i: number): FlowActionResolver;
    selectName(i: number): string;
}
export {};
