import { Router } from 'express';
import { OnCatchErrorHook } from './util';
import { TwilioControllerArgs } from './twllio';
import { ExitKeywordTest, Flow, FlowSchema, InteractionEndHook } from './Flows';
import { InteractionContext } from './SmsCookie';
export { Flow, FlowSchema, } from './Flows';
export { Message, Question, Trigger, Reply, } from './Actions';
declare type OnMessageHook = (context: InteractionContext, user: any, messageBody: string) => any;
declare type UserContextGetter = (from: string) => any;
interface TwillyParameters extends TwilioControllerArgs {
    cookieSecret?: string;
    getUserContext?: UserContextGetter;
    onCatchError?: OnCatchErrorHook;
    onInteractionEnd?: InteractionEndHook;
    onMessage?: OnMessageHook;
    root: Flow;
    schema?: FlowSchema;
    testForExit?: ExitKeywordTest;
}
export declare function twilly({ accountSid, authToken, messageServiceId, cookieKey, cookieSecret, getUserContext, onCatchError, onInteractionEnd, onMessage, root, schema, sendOnExit, testForExit, }: TwillyParameters): Router;
